SDL_SetAudioStreamGetCallback(3)

NAME
SDL_SetAudioStreamGetCallback - Set a callback that runs when data is requested from an audio stream.

HEADER FILE
Defined in SDL3/SDL_audio.h

SYNOPSIS
#include "SDL3/SDL.h"

int SDL_SetAudioStreamGetCallback(SDL_AudioStream *stream, SDL_AudioStreamCallback callback, void *userdata);

DESCRIPTION
This callback is called _before_ data is obtained from the stream, giving the callback the chance to add more on-demand. The callback can (optionally) call SDL_PutAudioStreamData () to add more audio to the stream during this call; if needed, the request that triggered this callback will obtain the new data immediately. The callback's approx_request argument is roughly how many bytes of _unconverted_ data (in the stream's input format) is needed by the caller, although this may overestimate a little for safety. This takes into account how much is already in the stream and only asks for any extra necessary to resolve the request, which means the callback may be asked for zero bytes, and a different amount on each call. The callback is not required to supply exact amounts; it is allowed to supply too much or too little or none at all. The caller will get what's available, up to the amount they requested, regardless of this callback's outcome. Clearing or flushing an audio stream does not call this callback. This function obtains the stream's lock, which means any existing callback (get or put) in progress will finish running before setting the new callback. Setting a NULL function turns off the callback.

FUNCTION PARAMETERS

stream
    the audio stream to set the new callback on.

callback
    the new callback function to call when data is added to the stream.

userdata
    an opaque pointer provided to the callback for its own personal use.

RETURN VALUE
Returns 0 on success, -1 on error. This only fails if stream is NULL.

THREAD SAFETY
It is safe to call this function from any thread.

AVAILABILITY
This function is available since SDL 3.0.0.

SEE ALSO
SDL_SetAudioStreamPutCallback(3)